library ieee;
use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity operazioni is
port(
 din: in std_logic_vector(15 downto 0);
 nw,clk: in std_logic;
 ris: out std_logic_vector(15 downto 0);
 fine: out std_logic
 );
end operazioni;

architecture beh of operazioni is
type stato is (idle, rd_op, rd_op1, rd_op2, rd_op3, calcola);
signal cs: stato;
signal a,b,c,tmp: std_logic_vector(15 downto 0);
signal op: std_logic_vector(1 downto 0);
signal tfine: std_logic;
--signal conta, numero: integer;
signal op_en, op1_en, op2_en, op3_en, calcola_en: std_logic;

begin

process(clk)
begin
 if clk'event and clk = '0' then
   case cs is
    when idle => if nw = '1' then cs <= rd_op;
                 end if;
    when rd_op => cs <= rd_op1;
    when rd_op1 => if op = "00" then cs <= calcola;
                   else cs <= rd_op2;
                   end if;
    when rd_op2 => if op = "01" or op = "10" then cs <= calcola;
                   else cs <= rd_op3;
                   end if;
    when rd_op3 => cs <= calcola;
    when others => cs <= idle;
   end case;
 end if;
end process;

process(cs)
begin
 case cs is
                
  when rd_op => op_en <= '1';
               op1_en <= '0';
               op2_en <= '0';
               op3_en <= '0';
               calcola_en <= '0'; 
               
  when rd_op1 => op_en <= '0';
               op1_en <= '1';
               op2_en <= '0';
               op3_en <= '0';
               calcola_en <= '0';
               
  when rd_op2 => op_en <= '0';
               op1_en <= '0';
               op2_en <= '1';
               op3_en <= '0';
               calcola_en <= '0';  
               
  when rd_op3 => op_en <= '0';
               op1_en <= '0';
               op2_en <= '0';
               op3_en <= '1';
               calcola_en <= '0';
               
  when calcola => op_en <= '0';
               op1_en <= '0';
               op2_en <= '0';
               op3_en <= '0';
               calcola_en <= '1';
               
  when others => op_en <= '0';
               op1_en <= '0';
               op2_en <= '0';
               op3_en <= '0';
               calcola_en <= '0';
 end case;
end process;

process (clk, nw)
begin
 
 if clk'event and clk = '0' then
   if nw = '1' and calcola_en/= '1' then fine <= '0';
   elsif calcola_en= '1' then fine <= '1';
   end if;
  
   if op_en = '1' then op <= din(1 downto 0);
   elsif op1_en = '1' then a <= din;
   elsif op2_en = '1' then b <= din;
   elsif op3_en = '1' then c <= din;
   elsif calcola_en = '1' then
    case op is
     when "00" => ris <= not a;
     when "01" => ris <= a + b;
     when "10" => ris <= a-b;
     when "11" => ris <= a+(b(7 downto 0) * c(7 downto 0));
     when others => null;
    end case;
  
   end if;
  end if;
end process;

end beh;

