library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity operazioni is
port ( A,B: in std_logic_vector(15 downto 0);
       nw,clk: in std_logic;
       Op: in std_logic_vector(2 downto 0);
       Dataout: out std_logic_vector(15 downto 0);
       ready: out std_logic
      );
end operazioni;

architecture beh of operazioni is
type stati is(idle,decodifica, operazione, prodotto);
signal state: stati;
signal a1,b1: std_logic_vector(15 downto 0);
signal op1: std_logic_vector(2 downto 0);
signal enable_operazione, enable_prodotto: std_logic;

signal conta: std_logic_vector(15 downto 0);
begin

-- process degli stati prossimi
process(clk)
begin
if clk'event and clk='0' then
   case state is
     when idle=> if nw='1' then state<=decodifica;
		 else state<=idle;
		 end if;
     when decodifica => case Op is 
                         when "000" | "001" | "010" | "011" => state<=operazione;
		   	 when "100" =>  state<=prodotto;
		   	 when others => state<=idle;
		   	end case;
    when operazione => state<=idle;
    when prodotto=>  if conta=b1(7 downto 0)-1 then state<=idle;
		    else     state<=prodotto;
		    end if;
    when others=> state <=idle;
  end case;
end if;
end process;

-- process dei segnali 

process(state)
begin
   case state is
		   	when operazione=>
		   	 	     enable_operazione<='1';
		   		     enable_prodotto<='0';
		  
		        when prodotto=> 
		   		     enable_operazione<='0';
		   		     enable_prodotto<='1';
			
			when others=> enable_operazione<='0';
		   		     enable_prodotto<='0';
		   end case;


end process;

-- process dei singoli stati:




process(clk)
variable  Sp: std_logic_vector(15 downto 0);
begin
if clk'event and clk='0' then 

 if nw ='1' then
			a1<=A;
			b1<=B;
			op1<=op;
			conta<= (conta'range=> '0');
			Sp := (Sp'range=> '0');
			
 elsif enable_operazione='1' then
   case op1 is
     when "000" =>  dataout<= a1+b1;
     when "001" =>  dataout<=  a1-b1;
     when "010" =>  dataout<=  a1 and b1;
     when "011" =>  dataout<=  a1 or b1;
     when others => null;
  end case;

 elsif enable_prodotto = '1' and  conta < b1 then
        Sp := Sp+a1(7 downto 0);
        conta <= conta + 1;
        if conta >= b1(7 downto 0)-1 then
           dataout <= Sp;
        end if;
 end if;
 
 
end if;
end process;


process(clk)
begin
if clk'event and clk='0' then 
   if enable_operazione= '1' or (enable_prodotto = '1' and conta >= b1-1) then ready <= '1';
   else ready <='0';
   end if;
end if;
end process;





end beh;

