library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



entity tb is
end tb;

architecture tbb of tb is
component operazioni is
port ( A,B: in std_logic_vector(15 downto 0);
       nw,clk: in std_logic;
       Op: in std_logic_vector(2 downto 0);
       Dataout: out std_logic_vector(15 downto 0);
       ready: out std_logic
      );
end component;


signal A,B: std_logic_vector(15 downto 0);
signal nw,clk: std_logic;
signal Op: std_logic_vector(2 downto 0);
signal Dataout: std_logic_vector(15 downto 0);
signal ready: std_logic;

begin

dut: operazioni port map (A,B,nw,clk,Op,Dataout,ready);

-- andamento del clock
process
begin
clk<='0';
wait for 5 ns;
clk<='1';
wait for 5 ns;
end process;

-- andamento del segnale di ingresso nw 
nw<='0'after 0 ns,'1' after 11 ns,'0' after 21 ns,
    '1' after 51 ns,'0' after 61 ns,
    '1' after 91 ns,'0' after 101 ns,
    '1' after 141 ns,'0' after 151 ns,
    '1' after 191 ns,'0' after 201 ns;

-- andamento dell'ingresso A
A <= conv_std_logic_vector(1,16) after 0 ns,
   conv_std_logic_vector(4,16) after 50 ns,
   conv_std_logic_vector(23,16) after 90 ns,
   conv_std_logic_vector(1,16) after 140 ns,
   conv_std_logic_vector(5,16) after 190 ns;

-- andamento dell'ingresso B
B<=conv_std_logic_vector(2,16) after 0 ns,
   conv_std_logic_vector(3,16) after 50 ns,
   conv_std_logic_vector(12,16) after 90 ns,
   conv_std_logic_vector(2,16) after 140 ns,
   conv_std_logic_vector(7,16) after 190 ns;
   
  
-- andamento del segnale di ingresso Op
Op<="000" after 0 ns, --somma
    "001" after 50 ns, --differenza
    "010" after 90 ns, -- and
    "011" after 140 ns, -- or
    "100" after 190 ns; -- prodotto

end tbb;

