-- Alessio Oglialoro 616002848
library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity operazione is
port (  V: in std_logic_vector(15 downto 0);
	I: in std_logic_vector(3 downto 0);
	nw,clk: std_logic;
	op: in std_logic_vector(1 downto 0);
	dataout: out std_logic_vector(15 downto 0);
	ready: out std_logic
	
	);
end operazione;

architecture th of operazione is

type stati is(idle,decodifica,leggi2,somma,prodotto,fine);
type memoria is array (0 to 15) of std_logic_vector(7 downto 0);


signal mem: memoria := ("00000001",
			"00000010",
			"00000001",
			"00000010",
			"00000001",
			"00000010",
			"00000001",
			"00000010",
			"00000001",
			"00000010",
			"00000001",
			"00000010",
			"00000001",
			"00000010",
			"00000001",
			"00000010");
signal nxt: stati:=idle;
signal temp: std_logic_vector(15 downto 0);
signal el,es,ep,update: std_logic;
signal cod: std_logic_vector(1 downto 0);
signal indice: integer;
signal operat1,operat2: std_logic_vector(15 downto 0);

begin

process(clk,nw)
variable conta: integer;
begin
if clk'event and clk='0' then
	case nxt is 
	  when idle => 
		conta:=0;
		if nw='1' then
			nxt<=decodifica;
		else    nxt<=idle;
		end if;
	when decodifica => 
		case cod is 
		 when "00" |  "10" => nxt<=leggi2;
		 when "11"  => nxt<=prodotto;
		 when "01"  => nxt<=somma;
		 when others => nxt <= idle;
		end case;
	when leggi2 => 
		 if cod="00" then nxt<=somma;
		 elsif cod="10" then nxt<=prodotto;
		 else nxt <= idle;
		 end if;
	
	when prodotto => if conta=1  then nxt<= fine;
			 else conta:= conta +1;
			 end if;
	when somma => nxt <= fine;
	when others => 	nxt<=idle;
	end case;
  end if;
end process;




process(nxt)
begin
	case nxt is 
	
	  when leggi2 =>
		el<='1';
		es<='0';
		ep<='0';
		update<='0';
	  when somma =>
		el<='0';
		es<='1';
		ep<='0';
		update<='0';
	  when prodotto =>
		el<='0';
		es<='0';
		ep<='1';
		update<='0';
	  when fine =>
		el<='0';
		es<='1';
		ep<='0';
		update<='1';
	  when others=>
		el<='0';
		es<='0';
		ep<='0';
		update<='0';
	end case;
	
end process;



process(clk,nxt)
begin
    if clk'event and clk='0' then		
	
	if nw = '1' then
		indice<=conv_integer(I);
		cod<=op;
		operat1<=V;
	end if;
	
	if el='1' then
			operat2<=V;
	end if;
	
	if es = '1' then 
	 if cod = "00" then
	 		temp<=operat1+operat2;
	 else 		temp<=operat1 + mem(indice);
	 end if;
	elsif ep = '1' then
	  if cod = "10" then
	    		temp<=operat1(7 downto 0)*operat2(7 downto 0);
	    else 	temp<=operat1(7 downto 0)*mem(indice);
	  end if;
	end if;
	  
	if(update='1') then
		dataout<=temp;
		ready<='1';
	else ready <= '0';
	end if;
  end if;
end process;



end th;

